* mulu3264
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.02 - 32 x 32 => 64
* V0.03 - using addx (wrong info on addx in MC68 manual!)
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef mulu3264

*
mulu3264
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Multiply two 32 bit unsigned integers using the sheep shit method
*
* For algorithm see past end, below
*
* This version supports a 64 bit result
*
*       Entry                Return
*                         d5.l result ms lw
*                         d4.l result ls lw
* d2.l = multiplier       d2.l smashed
* d1.l multiplicand       d1.l smashed
* d0.l                    d0.l smashed
*
* cc set on overflow
*
        clr.l d0        clear multiplicand upper long word
        clr.l d4        clear accumulator
        clr.l d5

        tst.l d2        0 x N = 0
        beq.s done

        tst.l d1        N x 0 = 0
        beq.s done

        cmp.l d1,d2     smallet number is multiplier
        bcs.s begin

        exg d1,d2
        bra.s begin

*
loop
        lsl.l #1,d0
        lsl.l #1,d1     double multiplicand
        bcc.s skip

        addq.l #1,d0    carry

skip
        lsr.l #1,d2     halve multiplier
        beq.s done       no more to do

begin
        btst #0,d2      if even..
        beq.s loop       ..skip, else..

        add.l d1,d4      ..accumulate lower
        addx.l d0,d5     ..accumulate upper w carry
        bra.s loop      continue

*
done
        rts

*
        end


Sheep shit multiplication method

You dont need to know your timestables nor even how to add to be able to
use this method of multiplication, only how to count! Follow the steps
below and you are guaranteed a correct result even if you happen to be a
calculator-less, illiterate peasant out in the field..

Scoop out a number of small holes or depressions in the ground in two
parallel columns, with the holes in the left column aligned with the holes
in the right column in rows. About ten holes in each column should suffice.
Now collect some stones, beads or sheep or camel droppings - we'll use
beads here - to be used as counters.

The column of rows on the left we may call the multiplicand, and on the
right the muliplier. Also scoop out two larger holes, one for storing the
beads to use, and the other for the result - call it the accumulator.

Say you have 63 sheep and you wish to sell them at 49 rials or shekels a
piece, and want to find the total sum for the transaction:

0. Empty the accumulator for any previous result
1. Put 63 beads in the topmost hole in the left column
2. Put 49 beads in the topmost hole in the right column
3. For each row in the rightmost column, starting at the top, put ONE bead
   in the hole immediadely below for every TWO beads in the row above until
   there's only one or no beeds left. (Any odd bead may be returned to the
   store.)
4. When you get to there being only one bead left to put in a hole, stop.
5. Now in the left column put TWO beads in the next hole for each ONE bead
   in the row above, until you get to the hole opposite the hole in the
   right column with only one bead in it. Then stop.

It should look something like this

	1: 	  63  x   49
	2:	 126	  24
	3:	 252	  12
	4:	 504	   6
	5:	1008	   3
	6:	2016	   1

6. For every hole in the left column that is OPPOSITE a hole in the
   right column with an ODD number of beads in it, take all the beads out
   and put them in the accumulator. (You can find out which right column
   holes have an odd number of beads by removing two beads a time until
   there is either only one bead (ODD) or no beads (EVEN) left.)

7. Now count the beads in the accumulator. That is your result! Ie:

   63 + 1008 + 2016 = 3087
   ----------------   ====

8. A slight tweak: It usually leads to a faster result by making
   the smallest number the multiplier (right column).
